X2Go Bug report logs - #611
X2Go Client for Windows cannot create C:\Users\<username>\ssh\known_hosts file when the username has characters from languages other than the system locale

version graph

Package: x2goclient; Maintainer for x2goclient is X2Go Developers <x2go-dev@lists.x2go.org>; Source for x2goclient is src:x2goclient.

Reported by: <trakatelis@uom.gr>

Date: Mon, 11 Aug 2014 10:55:01 UTC

Severity: normal

Found in version 4.0.2.1

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 11 Aug 2014 10:55:01 GMT) Full text and rfc822 format available.

Acknowledgement sent to <trakatelis@uom.gr>:
New Bug report received and forwarded. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 11 Aug 2014 10:55:02 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.x2go.org (full text, mbox):

From: George Trakatelis <trakatelis@gmail.com>
To: <submit@bugs.x2go.org>
Subject: X2Go Client for Windows 4.0.2.1 cannon create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-English characters
Date: Mon, 11 Aug 2014 13:51:21 +0300
Package: x2goclient
Version: 4.0.2.1

When I try to connect to a remote server, I cannot get past the pop-up

'Host key verification failed' 

The server is unknown. Do you trust the host key?
Public key hash: xxx.xxx.xxx.xxx:22 -
xx.xx.xx.xx.xx.xx.xx.xx.xx.xx.xx.xx.xx.xx.xx.xx

no matter how many times I click Yes. The pop-up appears again and again.

It seems that x2goclient cannot create the folder C:\Users\<username>\ssh
and the known_hosts file when <username> has non-English characters.

Confirmed that it works fine when <username> is in English.
  
I'm using Greek Windows 8.1 Pro 64-bit and X2Go Client for Windows
4.0.2.1+hotfix1+build3.



Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 01 Sep 2014 17:30:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to <trakatelis@uom.gr>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 01 Sep 2014 17:30:02 GMT) Full text and rfc822 format available.

Message #10 received at 566@bugs.x2go.org (full text, mbox):

From: George Trakatelis <trakatelis@uom.edu.gr>
To: <566@bugs.x2go.org>
Subject: RE: Bug#566: Acknowledgement (X2Go Client for Windows 4.0.2.1 cannon create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-English characters)
Date: Mon, 1 Sep 2014 20:28:50 +0300
A suggested patch is to substitute the Qt4 toAscii() function with toLocal8Bit() 
in two specific places of SshMasterConnection::run().
A git diff is as follows:

$ diff /c/a/sshmasterconnection.cpp /c/b/sshmasterconnection.cpp
521c521
<     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR, (mainWnd->getHomeDirectory()+"/ssh").toAscii());
---
>     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR, (mainWnd->getHomeDirectory()+"/ssh").toLocal8Bit());
630c630
<     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR, (mainWnd->getHomeDirectory()+"/ssh").toAscii());
---
>     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR, (mainWnd->getHomeDirectory()+"/ssh").toLocal8Bit());

The change affects only Windows builds and was tested in Windows 8.1 Pro and Windows 7 Professional.

G. Trakatelis


-----Original Message-----
From: X2Go Bug Tracking System [mailto:owner@bugs.x2go.org] 
Sent: Monday, August 11, 2014 1:55 PM
To: trakatelis@uom.gr
Subject: Bug#566: Acknowledgement (X2Go Client for Windows 4.0.2.1 cannon create C:\Users\<username>\ssh\known_hosts file 
when the local Windows account username has non-English characters)

...

--
566: http://bugs.x2go.org/cgi-bin/bugreport.cgi?bug=566
X2Go Bug Tracking System
Contact owner@bugs.x2go.org with problems


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 01 Sep 2014 19:55:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 01 Sep 2014 19:55:02 GMT) Full text and rfc822 format available.

Message #15 received at 566@bugs.x2go.org (full text, mbox):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: trakatelis@uom.gr, 566@bugs.x2go.org, George Trakatelis <trakatelis@uom.edu.gr>
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannon create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-English characters
Date: Mon, 01 Sep 2014 19:51:03 +0000
[Message part 1 (text/plain, inline)]
Hi Mike#2,

On  Mo 01 Sep 2014 19:28:50 CEST, George Trakatelis wrote:

> A suggested patch is to substitute the Qt4 toAscii() function with  
> toLocal8Bit()
> in two specific places of SshMasterConnection::run().
> A git diff is as follows:
>
> $ diff /c/a/sshmasterconnection.cpp /c/b/sshmasterconnection.cpp
> 521c521
> <     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,  
> (mainWnd->getHomeDirectory()+"/ssh").toAscii());
> ---
>>     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,  
>> (mainWnd->getHomeDirectory()+"/ssh").toLocal8Bit());
> 630c630
> <     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,  
> (mainWnd->getHomeDirectory()+"/ssh").toAscii());
> ---
>>     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,  
>> (mainWnd->getHomeDirectory()+"/ssh").toLocal8Bit());
>
> The change affects only Windows builds and was tested in Windows 8.1  
> Pro and Windows 7 Professional.
>
> G. Trakatelis

Can you review these changes and if appropriate commit them to the  
master branch of x2goclient.git?

Thanks!
Mike


-- 

DAS-NETZWERKTEAM
mike gabriel, herweg 7, 24357 fleckeby
fon: +49 (1520) 1976 148

GnuPG Key ID 0x25771B31
mail: mike.gabriel@das-netzwerkteam.de, http://das-netzwerkteam.de

freeBusy:
https://mail.das-netzwerkteam.de/freebusy/m.gabriel%40das-netzwerkteam.de.xfb
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 01 Sep 2014 23:25:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael DePaulo <mikedep333@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 01 Sep 2014 23:25:02 GMT) Full text and rfc822 format available.

Message #20 received at 566@bugs.x2go.org (full text, mbox):

From: Michael DePaulo <mikedep333@gmail.com>
To: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>, 566@bugs.x2go.org
Cc: trakatelis@uom.gr, George Trakatelis <trakatelis@uom.edu.gr>
Subject: Re: [X2Go-Dev] Bug#566: Bug#566: X2Go Client for Windows 4.0.2.1 cannon create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-English characters
Date: Mon, 1 Sep 2014 19:23:12 -0400
On Mon, Sep 1, 2014 at 3:51 PM, Mike Gabriel
<mike.gabriel@das-netzwerkteam.de> wrote:
> Hi Mike#2,
>
> On  Mo 01 Sep 2014 19:28:50 CEST, George Trakatelis wrote:
>
>> A suggested patch is to substitute the Qt4 toAscii() function with
>> toLocal8Bit()
>> in two specific places of SshMasterConnection::run().
>> A git diff is as follows:
>>
>> $ diff /c/a/sshmasterconnection.cpp /c/b/sshmasterconnection.cpp
>> 521c521
>> <     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,
>> (mainWnd->getHomeDirectory()+"/ssh").toAscii());
>> ---
>>>
>>>     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,
>>> (mainWnd->getHomeDirectory()+"/ssh").toLocal8Bit());
>>
>> 630c630
>> <     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,
>> (mainWnd->getHomeDirectory()+"/ssh").toAscii());
>> ---
>>>
>>>     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,
>>> (mainWnd->getHomeDirectory()+"/ssh").toLocal8Bit());
>>
>>
>> The change affects only Windows builds and was tested in Windows 8.1 Pro
>> and Windows 7 Professional.
>>
>> G. Trakatelis
>
>
> Can you review these changes and if appropriate commit them to the master
> branch of x2goclient.git?
>
> Thanks!
> Mike
>
> [...]

Sure. I'm busy today, but I'll do so within the next few/several days.

-Mike


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Sun, 07 Sep 2014 04:45:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael DePaulo <mikedep333@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Sun, 07 Sep 2014 04:45:02 GMT) Full text and rfc822 format available.

Message #25 received at 566@bugs.x2go.org (full text, mbox):

From: Michael DePaulo <mikedep333@gmail.com>
To: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>, 566@bugs.x2go.org
Cc: trakatelis@uom.gr, George Trakatelis <trakatelis@uom.edu.gr>
Subject: Re: [X2Go-Dev] Bug#566: Bug#566: X2Go Client for Windows 4.0.2.1 cannon create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-English characters
Date: Sun, 7 Sep 2014 00:44:25 -0400
[Message part 1 (text/plain, inline)]
Hi George,

1st, please use either "diff -c" or "git diff" to prepare the patch.
You can even use "git diff" on a files/folders that are outisde of a
git source tree.

2nd, I tried what I think was your patch. I've attached the change I
used, it is outputted with "git diff". I used the x2goclient master
branch (4.0.3.0.)

Unfortunately, it failed to fix the bug. I did not experience any
regressions though.

I tested it on both a Windows XP 32-bit SP3 machine and a Windows 8.1
64-bit machine (with the latest required updates & optional updates
from MS.)

3rd, the username I used was "δοκιμαστικό χρήστη". That is how Google
Translate translated "test user" into Greek. Because it is not easy
for me to type that name into the Windows login prompt, I simply ran
commands like the following to test it:
runas "/user:δοκιμαστικό χρήστη" "c:\x2gobuilds\x2goclient\dist\x2goclient.exe"

-Mike

On Mon, Sep 1, 2014 at 7:23 PM, Michael DePaulo <mikedep333@gmail.com> wrote:
> On Mon, Sep 1, 2014 at 3:51 PM, Mike Gabriel
> <mike.gabriel@das-netzwerkteam.de> wrote:
>> Hi Mike#2,
>>
>> On  Mo 01 Sep 2014 19:28:50 CEST, George Trakatelis wrote:
>>
>>> A suggested patch is to substitute the Qt4 toAscii() function with
>>> toLocal8Bit()
>>> in two specific places of SshMasterConnection::run().
>>> A git diff is as follows:
>>>
>>> $ diff /c/a/sshmasterconnection.cpp /c/b/sshmasterconnection.cpp
>>> 521c521
>>> <     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,
>>> (mainWnd->getHomeDirectory()+"/ssh").toAscii());
>>> ---
>>>>
>>>>     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,
>>>> (mainWnd->getHomeDirectory()+"/ssh").toLocal8Bit());
>>>
>>> 630c630
>>> <     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,
>>> (mainWnd->getHomeDirectory()+"/ssh").toAscii());
>>> ---
>>>>
>>>>     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,
>>>> (mainWnd->getHomeDirectory()+"/ssh").toLocal8Bit());
>>>
>>>
>>> The change affects only Windows builds and was tested in Windows 8.1 Pro
>>> and Windows 7 Professional.
>>>
>>> G. Trakatelis
>>
>>
>> Can you review these changes and if appropriate commit them to the master
>> branch of x2goclient.git?
>>
>> Thanks!
>> Mike
>>
>> [...]
>
> Sure. I'm busy today, but I'll do so within the next few/several days.
>
> -Mike
[bug566.test.patch (application/octet-stream, attachment)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Sun, 07 Sep 2014 10:05:01 GMT) Full text and rfc822 format available.

Acknowledgement sent to "George Trakatelis" <trakatelis@uom.edu.gr>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Sun, 07 Sep 2014 10:05:01 GMT) Full text and rfc822 format available.

Message #30 received at 566@bugs.x2go.org (full text, mbox):

From: "George Trakatelis" <trakatelis@uom.edu.gr>
To: <566@bugs.x2go.org>
Cc: "'Michael DePaulo'" <mikedep333@gmail.com>
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Sun, 7 Sep 2014 13:04:51 +0300
[Message part 1 (text/plain, inline)]
Hi Mike,

1st, Ok.

2nd, You guessed right, so I have attached the very same file.

3rd, Your findings really puzzled me, so I did the following:

a. Installed German keyboard. Hit ';' to produce an accented letter
and -to my surprise- got ö. So I thought ölexandr was the right name to test for username.

b. Created user ölexandr and logged in as that user.
The patch did not work, as you mentioned.

c. As toLocal8Bit() returns the local 8-bit representation of a string,
I changed the system locale for non-unicode programs to German.
Now the patch worked!

I think the patch solves the problem for the Windows users who use English
as a foreign language and prefer having (non-Ascii) usernames in their native language.

-George

PS. A better title for the bug would be

X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters


-----Αρχικό μήνυμα-----
Από: Michael DePaulo [mailto:mikedep333@gmail.com] 
Αποστολή: Κυριακή, 7 Σεπτεμβρίου 2014 7:44 πμ
Προς: Mike Gabriel; 566@bugs.x2go.org
Κοιν.: trakatelis@uom.gr; George Trakatelis
Θέμα: Re: [X2Go-Dev] Bug#566: Bug#566: X2Go Client for Windows 4.0.2.1 cannon create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-English characters

Hi George,

1st, please use either "diff -c" or "git diff" to prepare the patch.
You can even use "git diff" on a files/folders that are outisde of a git source tree.

2nd, I tried what I think was your patch. I've attached the change I used, it is outputted with "git diff". I used the x2goclient master branch (4.0.3.0.)

Unfortunately, it failed to fix the bug. I did not experience any regressions though.

I tested it on both a Windows XP 32-bit SP3 machine and a Windows 8.1 64-bit machine (with the latest required updates & optional updates from MS.)

3rd, the username I used was "δοκιμαστικό χρήστη". That is how Google Translate translated "test user" into Greek. Because it is not easy for me to type that name into the Windows login prompt, I simply ran commands like the following to test it:
runas "/user:δοκιμαστικό χρήστη" "c:\x2gobuilds\x2goclient\dist\x2goclient.exe"

-Mike
[bug566.patch (application/octet-stream, attachment)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Sun, 07 Sep 2014 13:25:01 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael DePaulo <mikedep333@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Sun, 07 Sep 2014 13:25:01 GMT) Full text and rfc822 format available.

Message #35 received at 566@bugs.x2go.org (full text, mbox):

From: Michael DePaulo <mikedep333@gmail.com>
To: George Trakatelis <trakatelis@uom.edu.gr>, 566@bugs.x2go.org, Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Sun, 7 Sep 2014 09:23:22 -0400
[Message part 1 (text/plain, inline)]
On Sun, Sep 7, 2014 at 6:04 AM, George Trakatelis <trakatelis@uom.edu.gr> wrote:
[...]
>
> a. Installed German keyboard. Hit ';' to produce an accented letter
> and -to my surprise- got ö. So I thought ölexandr was the right name to test for username.
>
> b. Created user ölexandr and logged in as that user.
> The patch did not work, as you mentioned.
>
> c. As toLocal8Bit() returns the local 8-bit representation of a string,
> I changed the system locale for non-unicode programs to German.
> Now the patch worked!
>
> I think the patch solves the problem for the Windows users who use English
> as a foreign language and prefer having (non-Ascii) usernames in their native language.
>
> -George
>
> PS. A better title for the bug would be
>
> X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters

Hi Mike#1 and George,

1. What do you think of using toUtf8() instead? I am hoping that will
fix the bug regardless of the locale.

I tried changing it to that (bug566.utf8.test.patch), but it still did
not fix this bug with the greek username on my system with the locale
set to English. It did not introduce a regression for my ASCII user
account at least.

If libssh needs to be recompiled for Unicode, I can do that. I just
recompiled it for bug #590.

FYI: This is the API we are calling:
http://api.libssh.org/stable/group__libssh__session.html#ga7a801b85800baa3f4e16f5b47db0a73d

2. in sshmasterconnection.cpp, we also set "SSH_OPTIONS_USER" . I
think that we should also change its value from to.Ascii() to
toLocal8Bit() or toUtf8(). bug566.test.v2.patch has this change for
toLocal8Bit(), and bug566.utf8.test.patch has it for toUtf8().

-Mike#2
[bug566.test.v2.patch (application/octet-stream, attachment)]
[bug566.utf8.test.patch (application/octet-stream, attachment)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 08 Sep 2014 00:15:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to "George Trakatelis" <trakatelis@uom.edu.gr>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 08 Sep 2014 00:15:02 GMT) Full text and rfc822 format available.

Message #40 received at 566@bugs.x2go.org (full text, mbox):

From: "George Trakatelis" <trakatelis@uom.edu.gr>
To: <566@bugs.x2go.org>
Cc: "'Michael DePaulo'" <mikedep333@gmail.com>, "'Mike Gabriel'" <mike.gabriel@das-netzwerkteam.de>
Subject: RE: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Mon, 8 Sep 2014 03:13:48 +0300
Hi Mike,

1. If you recompile libssh 0.6.3 with Unicode support and provide me with a download link,
I will happily test it on all Windows platforms (namely Windows 8, 7, and XP).

2. I agree.

-George

-----Original Message-----
From: Michael DePaulo [mailto:mikedep333@gmail.com] 
Sent: Sunday, September 7, 2014 4:23 PM
To: George Trakatelis; 566@bugs.x2go.org; Mike Gabriel
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters

[...]

Hi Mike#1 and George,

1. What do you think of using toUtf8() instead? I am hoping that will fix the bug regardless of the locale.

I tried changing it to that (bug566.utf8.test.patch), but it still did not fix this bug with the greek username on my system with the locale set to English. It did not introduce a regression for my ASCII user account at least.

If libssh needs to be recompiled for Unicode, I can do that. I just recompiled it for bug #590.

FYI: This is the API we are calling:
http://api.libssh.org/stable/group__libssh__session.html#ga7a801b85800baa3f4e16f5b47db0a73d

2. in sshmasterconnection.cpp, we also set "SSH_OPTIONS_USER" . I think that we should also change its value from to.Ascii() to
toLocal8Bit() or toUtf8(). bug566.test.v2.patch has this change for toLocal8Bit(), and bug566.utf8.test.patch has it for toUtf8().

-Mike#2


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 08 Sep 2014 03:00:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael DePaulo <mikedep333@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 08 Sep 2014 03:00:02 GMT) Full text and rfc822 format available.

Message #45 received at 566@bugs.x2go.org (full text, mbox):

From: Michael DePaulo <mikedep333@gmail.com>
To: George Trakatelis <trakatelis@uom.edu.gr>
Cc: 566@bugs.x2go.org, Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Sun, 7 Sep 2014 22:55:13 -0400
Yeah. I think that libssh isn't being compiled with Unicode support,
or at least not under MingW 4.4. It's not 100% clear how to compile a
C library with Unicode support under MinGW and CMake. For example,
recent versions of MinGW let you specify the linker option -municode.
But I cannot find a single release note that states when exactly that
feature was added. I do not know if 4.4 has it or not.

I'm going to try to compile it with MinGW 4.8. I've been meaning to
upgrade to X2Go to MinGW 4.8 and QT 4.8.6 anyway. (bug: #474)

On Sun, Sep 7, 2014 at 8:13 PM, George Trakatelis <trakatelis@uom.edu.gr> wrote:
> Hi Mike,
>
> 1. If you recompile libssh 0.6.3 with Unicode support and provide me with a download link,
> I will happily test it on all Windows platforms (namely Windows 8, 7, and XP).
>
> 2. I agree.
>
> -George
>
> -----Original Message-----
> From: Michael DePaulo [mailto:mikedep333@gmail.com]
> Sent: Sunday, September 7, 2014 4:23 PM
> To: George Trakatelis; 566@bugs.x2go.org; Mike Gabriel
> Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
>
> [...]
>
> Hi Mike#1 and George,
>
> 1. What do you think of using toUtf8() instead? I am hoping that will fix the bug regardless of the locale.
>
> I tried changing it to that (bug566.utf8.test.patch), but it still did not fix this bug with the greek username on my system with the locale set to English. It did not introduce a regression for my ASCII user account at least.
>
> If libssh needs to be recompiled for Unicode, I can do that. I just recompiled it for bug #590.
>
> FYI: This is the API we are calling:
> http://api.libssh.org/stable/group__libssh__session.html#ga7a801b85800baa3f4e16f5b47db0a73d
>
> 2. in sshmasterconnection.cpp, we also set "SSH_OPTIONS_USER" . I think that we should also change its value from to.Ascii() to
> toLocal8Bit() or toUtf8(). bug566.test.v2.patch has this change for toLocal8Bit(), and bug566.utf8.test.patch has it for toUtf8().
>
> -Mike#2
>


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 08 Sep 2014 08:55:01 GMT) Full text and rfc822 format available.

Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 08 Sep 2014 08:55:01 GMT) Full text and rfc822 format available.

Message #50 received at 566@bugs.x2go.org (full text, mbox):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: George Trakatelis <trakatelis@uom.edu.gr>, 566@bugs.x2go.org
Subject: Re: [X2Go-Dev] Bug#566: Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Mon, 08 Sep 2014 08:52:31 +0000
[Message part 1 (text/plain, inline)]
Hi Mike#2, hi George,

On  So 07 Sep 2014 12:04:51 CEST, George Trakatelis wrote:

> c. As toLocal8Bit() returns the local 8-bit representation of a string,
> I changed the system locale for non-unicode programs to German.
> Now the patch worked!
>
> I think the patch solves the problem for the Windows users who use English
> as a foreign language and prefer having (non-Ascii) usernames in  
> their native language.
>
> -George
>
> PS. A better title for the bug would be
>
> X2Go Client for Windows 4.0.2.1 cannot create  
> C:\Users\<username>\ssh\known_hosts file when the local Windows  
> account username has non-Ascii characters

Now that I think of it more thoroughly... Shouldn't we do a proper  
encode/decode here so that we convert UTF-8 to Windows-CP1251 encoding  
[1]?

Alternatively, one could work with filenames in UTF-16 as shown in  
this [2] example.

I am not sure about the exact position in the code that bugs this up,  
but I fear, the solution is non-trivial.

Either you need to detect the client-side encoding and convert between  
UTF-8 and that encoding, or we may consider addressing file names in  
UTF-16 (if that is possible in Qt).

Unfortunately, it seems that Windows uses different encodings at  
different places (e.g. command.exe vs. Windows Explorer).

Just guessing after a little bit of internet research on this,
Mike#1


[1] http://comments.gmane.org/gmane.comp.lib.qt.general/39868
[2] https://www.mail-archive.com/subsurface@hohndel.org/msg00099.html


-- 

DAS-NETZWERKTEAM
mike gabriel, herweg 7, 24357 fleckeby
fon: +49 (1520) 1976 148

GnuPG Key ID 0x25771B31
mail: mike.gabriel@das-netzwerkteam.de, http://das-netzwerkteam.de

freeBusy:
https://mail.das-netzwerkteam.de/freebusy/m.gabriel%40das-netzwerkteam.de.xfb
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 08 Sep 2014 09:00:01 GMT) Full text and rfc822 format available.

Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 08 Sep 2014 09:00:02 GMT) Full text and rfc822 format available.

Message #55 received at 566@bugs.x2go.org (full text, mbox):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: Michael DePaulo <mikedep333@gmail.com>
Cc: George Trakatelis <trakatelis@uom.edu.gr>, 566@bugs.x2go.org
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Mon, 08 Sep 2014 08:58:33 +0000
[Message part 1 (text/plain, inline)]
Hi Mike#2,

On  So 07 Sep 2014 15:23:22 CEST, Michael DePaulo wrote:

> On Sun, Sep 7, 2014 at 6:04 AM, George Trakatelis  
> <trakatelis@uom.edu.gr> wrote:
> [...]
>>
>> a. Installed German keyboard. Hit ';' to produce an accented letter
>> and -to my surprise- got ö. So I thought ölexandr was the right  
>> name to test for username.
>>
>> b. Created user ölexandr and logged in as that user.
>> The patch did not work, as you mentioned.
>>
>> c. As toLocal8Bit() returns the local 8-bit representation of a string,
>> I changed the system locale for non-unicode programs to German.
>> Now the patch worked!
>>
>> I think the patch solves the problem for the Windows users who use English
>> as a foreign language and prefer having (non-Ascii) usernames in  
>> their native language.
>>
>> -George
>>
>> PS. A better title for the bug would be
>>
>> X2Go Client for Windows 4.0.2.1 cannot create  
>> C:\Users\<username>\ssh\known_hosts file when the local Windows  
>> account username has non-Ascii characters
>
> Hi Mike#1 and George,
>
> 1. What do you think of using toUtf8() instead? I am hoping that will
> fix the bug regardless of the locale.
>
> I tried changing it to that (bug566.utf8.test.patch), but it still did
> not fix this bug with the greek username on my system with the locale
> set to English. It did not introduce a regression for my ASCII user
> account at least.
>
> If libssh needs to be recompiled for Unicode, I can do that. I just
> recompiled it for bug #590.
>
> FYI: This is the API we are calling:
> http://api.libssh.org/stable/group__libssh__session.html#ga7a801b85800baa3f4e16f5b47db0a73d

I am getting the suspicion, that this is a libssh issue.

X2Go Client and libssh should communicate via UTF-8 (because it is  
_the_ encoding that applications use internally, nowadays) and libssh  
should handle whatever conversion (probably to UTF-16 wide string?) is  
necessary for creating files, being aware of usernames, etc.

> 2. in sshmasterconnection.cpp, we also set "SSH_OPTIONS_USER" . I
> think that we should also change its value from to.Ascii() to
> toLocal8Bit() or toUtf8(). bug566.test.v2.patch has this change for
> toLocal8Bit(), and bug566.utf8.test.patch has it for toUtf8().

Same thing. SSH_OPTIONS_USER should be set as UTF-8 and libssh should  
convert to whatever encoding is needed.

Greets,
Mike

-- 

DAS-NETZWERKTEAM
mike gabriel, herweg 7, 24357 fleckeby
fon: +49 (1520) 1976 148

GnuPG Key ID 0x25771B31
mail: mike.gabriel@das-netzwerkteam.de, http://das-netzwerkteam.de

freeBusy:
https://mail.das-netzwerkteam.de/freebusy/m.gabriel%40das-netzwerkteam.de.xfb
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Tue, 09 Sep 2014 13:20:01 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael DePaulo <mikedep333@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Tue, 09 Sep 2014 13:20:02 GMT) Full text and rfc822 format available.

Message #60 received at 566@bugs.x2go.org (full text, mbox):

From: Michael DePaulo <mikedep333@gmail.com>
To: 566@bugs.x2go.org
Cc: George Trakatelis <trakatelis@uom.edu.gr>, Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Tue, 9 Sep 2014 09:15:52 -0400
[Message part 1 (text/plain, inline)]
On Mon, Sep 8, 2014 at 4:58 AM, Mike Gabriel
<mike.gabriel@das-netzwerkteam.de> wrote:
> Hi Mike#2,
>
>
> On  So 07 Sep 2014 15:23:22 CEST, Michael DePaulo wrote:
>
>> On Sun, Sep 7, 2014 at 6:04 AM, George Trakatelis <trakatelis@uom.edu.gr>
>> wrote:
>> [...]
>>>
>>>
>>> a. Installed German keyboard. Hit ';' to produce an accented letter
>>> and -to my surprise- got ö. So I thought ölexandr was the right name to
>>> test for username.
>>>
>>> b. Created user ölexandr and logged in as that user.
>>> The patch did not work, as you mentioned.
>>>
>>> c. As toLocal8Bit() returns the local 8-bit representation of a string,
>>> I changed the system locale for non-unicode programs to German.
>>> Now the patch worked!
>>>
>>> I think the patch solves the problem for the Windows users who use
>>> English
>>> as a foreign language and prefer having (non-Ascii) usernames in their
>>> native language.
>>>
>>> -George
>>>
>>> PS. A better title for the bug would be
>>>
>>> X2Go Client for Windows 4.0.2.1 cannot create
>>> C:\Users\<username>\ssh\known_hosts file when the local Windows account
>>> username has non-Ascii characters
>>
>>
>> Hi Mike#1 and George,
>>
>> 1. What do you think of using toUtf8() instead? I am hoping that will
>> fix the bug regardless of the locale.
>>
>> I tried changing it to that (bug566.utf8.test.patch), but it still did
>> not fix this bug with the greek username on my system with the locale
>> set to English. It did not introduce a regression for my ASCII user
>> account at least.
>>
>> If libssh needs to be recompiled for Unicode, I can do that. I just
>> recompiled it for bug #590.
>>
>> FYI: This is the API we are calling:
>>
>> http://api.libssh.org/stable/group__libssh__session.html#ga7a801b85800baa3f4e16f5b47db0a73d
>
>
> I am getting the suspicion, that this is a libssh issue.
>
> X2Go Client and libssh should communicate via UTF-8 (because it is _the_
> encoding that applications use internally, nowadays) and libssh should
> handle whatever conversion (probably to UTF-16 wide string?) is necessary
> for creating files, being aware of usernames, etc.
>
>> 2. in sshmasterconnection.cpp, we also set "SSH_OPTIONS_USER" . I
>> think that we should also change its value from to.Ascii() to
>> toLocal8Bit() or toUtf8(). bug566.test.v2.patch has this change for
>> toLocal8Bit(), and bug566.utf8.test.patch has it for toUtf8().
>
>
> Same thing. SSH_OPTIONS_USER should be set as UTF-8 and libssh should
> convert to whatever encoding is needed.
>
> Greets,
> Mike
[...]

Hi Mike#1 and George,

1.

I believe the best approach is to try to compile libssh with unicode
support, and pass unicode values to it. There is no guarantee that a
user's username (and home dir path) is in the same language as the
language that is set for non-Unicode programs. After all, the
"Language for non-Unicode programs" is called the "system locale", it
applies to all users on the system.

If we have to for the 4.0.3.0 release of x2goclient, we should fix
this bug for the system locale only, and then fix the bug for all
languages/locales later.

2.

See bug 474 for George's patch for compiling libssh with MinGW 4.8.2.
It worked :)

3.

I made some progress compiling libssh 0.6.3 with Unicode support.

With MinGW 4.4, when I specified the following values in CMAKE, libssh
built successfully, but it did not seem to change anything.
CMAKE_EXE_LINKER_FLAGS:STRING=-municode
CMAKE_MODULE_LINKER_FLAGS:STRING=-municode
CMAKE_SHARED_LINKER_FLAGS:STRING=-municode
CMAKE_STATIC_LINKER_FLAGS:STRING=-municode

With MinGW 4.8.2, when I specify those values, libssh fails to build.
I've attached the output.

This is a positive sign because it implies that MinGW 4.8.2 supports
-municode, whereas MinGW 4.4 did not.

I plan to try to resolve this build failure later tonight.

-Mike#2
[libssh-0.6.3-fails-to-build-mingw4.8.2-and--municode.txt (text/plain, attachment)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Thu, 11 Sep 2014 12:15:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael DePaulo <mikedep333@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Thu, 11 Sep 2014 12:15:02 GMT) Full text and rfc822 format available.

Message #65 received at 566@bugs.x2go.org (full text, mbox):

From: Michael DePaulo <mikedep333@gmail.com>
To: 566@bugs.x2go.org
Subject: Successful compile, but no bugfix
Date: Thu, 11 Sep 2014 08:12:34 -0400
I managed to compile libssh successfully, but I am not sure if it
actually is compiled with unicode support. I say this because the utf8
patch does not fix this bug.

My friend Mike Frederick expressed interest in helping me, so here are
all the details of how I built:

As mentioned in bug 474, I am using this build of mingw 4.8.2, which
QT 4.8.6 wants:
http://sourceforge.net/projects/mingw-w64/files/Toolchains%20targetting%20Win32/Personal%20Builds/mingw-builds/4.8.2/threads-posix/dwarf/i686-4.8.2-release-posix-dwarf-rt_v3-rev3.7z/download

I am using CMake 2.8.12.2 (the latest 2.x version):
http://www.cmake.org/files/v2.8/cmake-2.8.12.2-win32-x86.exe

openssl 1.0.1i
http://slproweb.com/download/Win32OpenSSL-1_0_1i.exe

zlib 1.2.8
http://zlib.net/zlib128-dll.zip

These are the CMake options I specified:
CMAKE_CXX_FLAGS:STRING=-DUNICODE -D_UNICODE
CMAKE_C_FLAGS:STRING=-DUNICODE -D_UNICODE
CMAKE_EXE_LINKER_FLAGS:STRING=-municode
CMAKE_MODULE_LINKER_FLAGS:STRING=-municode
CMAKE_SHARED_LINKER_FLAGS:STRING=-municode
CMAKE_STATIC_LINKER_FLAGS:STRING=-municode
WITH_EXAMPLES:BOOL=OFF
(In addition to specifying ZLIB_ROOT_DIR)

The exact source I am using is this tarball:
http://code.x2go.org/releases/source/libssh-modified-by-x2go-project/libssh-0.6.3-762055b-pageant-support-mingw482.src.zip

Which is libssh-0.6.3 with these 2 patches applied:
http://code.x2go.org/releases/source/libssh-modified-by-x2go-project/implement-support-for-putty-s-pageant-0.6.3-de62963.patch
http://code.x2go.org/releases/source/libssh-modified-by-x2go-project/libssh-0.6.3-pthread.c.relativepaths.patch


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Thu, 11 Sep 2014 19:15:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Thu, 11 Sep 2014 19:15:02 GMT) Full text and rfc822 format available.

Message #70 received at 566@bugs.x2go.org (full text, mbox):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: Michael DePaulo <mikedep333@gmail.com>, 566@bugs.x2go.org
Subject: Re: [X2Go-Dev] Bug#566: Successful compile, but no bugfix
Date: Thu, 11 Sep 2014 19:11:15 +0000
[Message part 1 (text/plain, inline)]
Hi Mike#2,

On  Do 11 Sep 2014 14:12:34 CEST, Michael DePaulo wrote:

> My friend Mike Frederick expressed interest in helping me, so here are
> all the details of how I built:

/me waves to "Mike#3"!!!

Mike#1

-- 

DAS-NETZWERKTEAM
mike gabriel, herweg 7, 24357 fleckeby
fon: +49 (1520) 1976 148

GnuPG Key ID 0x25771B31
mail: mike.gabriel@das-netzwerkteam.de, http://das-netzwerkteam.de

freeBusy:
https://mail.das-netzwerkteam.de/freebusy/m.gabriel%40das-netzwerkteam.de.xfb
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 15 Sep 2014 05:30:01 GMT) Full text and rfc822 format available.

Acknowledgement sent to "George Trakatelis" <trakatelis@uom.edu.gr>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 15 Sep 2014 05:30:02 GMT) Full text and rfc822 format available.

Message #75 received at 566@bugs.x2go.org (full text, mbox):

From: "George Trakatelis" <trakatelis@uom.edu.gr>
To: <566@bugs.x2go.org>
Cc: "'Michael DePaulo'" <mikedep333@gmail.com>
Subject: RE: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Mon, 15 Sep 2014 08:26:40 +0300
Dear Mike,

I have built libssh 0.6.3 in Visual Studio 2013 (with UNICODE and _UNICODE defined in all projects)
and debugged a tiny test app with function calls analogous to those used in x2goclient.
I'm afraid preprocessor definitions are not enough to make an application/program/library support Unicode.
One could migrate existing programs following a list of guidelines

http://msdn.microsoft.com/en-us/library/cc194801.aspx

For example, a function that fails in libssh (used in ssh_path_expand_tilde(), 
which is always called to replace a ~ with the actual home folder path in a string) is strdup.
To make libssh unicode-friendly strdup has to be replaced by _strdup

http://msdn.microsoft.com/en-us/library/y471khhc.aspx

_strdup would benefit from preprocessor definitions for Unicode support
as it would be converted to the proper Unicode function.

Imho, the only option for now is patch "bug566.test.v2.patch"
as it corrects the problem in the vast majority of Windows installations.
Remember that foreign Windows installations set by default the 
"Language for non-Unicode programs" to that particular foreign language.

-George

-----Original Message-----
From: Michael DePaulo [mailto:mikedep333@gmail.com] 
Sent: Tuesday, September 9, 2014 4:16 PM
To: 566@bugs.x2go.org
Cc: George Trakatelis; Mike Gabriel
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters

[...]

Hi Mike#1 and George,

1.

I believe the best approach is to try to compile libssh with unicode support, and pass unicode values to it. There is no guarantee that a user's username (and home dir path) is in the same language as the language that is set for non-Unicode programs. After all, the "Language for non-Unicode programs" is called the "system locale", it applies to all users on the system.

If we have to for the 4.0.3.0 release of x2goclient, we should fix this bug for the system locale only, and then fix the bug for all languages/locales later.

2.

See bug 474 for George's patch for compiling libssh with MinGW 4.8.2.
It worked :)

3.

I made some progress compiling libssh 0.6.3 with Unicode support.

With MinGW 4.4, when I specified the following values in CMAKE, libssh built successfully, but it did not seem to change anything.
CMAKE_EXE_LINKER_FLAGS:STRING=-municode
CMAKE_MODULE_LINKER_FLAGS:STRING=-municode
CMAKE_SHARED_LINKER_FLAGS:STRING=-municode
CMAKE_STATIC_LINKER_FLAGS:STRING=-municode

With MinGW 4.8.2, when I specify those values, libssh fails to build.
I've attached the output.

This is a positive sign because it implies that MinGW 4.8.2 supports -municode, whereas MinGW 4.4 did not.

I plan to try to resolve this build failure later tonight.

-Mike#2


Changed Bug title to 'X2Go Client for Windows cannot create' from 'X2Go Client for Windows 4.0.2.1 cannon create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-English characters' Request was from Michael DePaulo <mikedep333@gmail.com> to control@bugs.x2go.org. (Mon, 15 Sep 2014 16:30:01 GMT) Full text and rfc822 format available.

Bug 566 cloned as bug 611 Request was from Michael DePaulo <mikedep333@gmail.com> to control@bugs.x2go.org. (Mon, 15 Sep 2014 16:30:01 GMT) Full text and rfc822 format available.

Changed Bug title to '"X2Go Client for Windows cannot create' from 'X2Go Client for Windows cannot create' Request was from Michael DePaulo <mikedep333@gmail.com> to control@bugs.x2go.org. (Mon, 15 Sep 2014 16:35:02 GMT) Full text and rfc822 format available.

Changed Bug title to 'X2Go Client for Windows cannot create C:\Users\<username>\ssh\known_hosts file when the username has characters from languages other than the system locale' from '"X2Go Client for Windows cannot create' Request was from Michael DePaulo <mikedep333@gmail.com> to control@bugs.x2go.org. (Tue, 16 Sep 2014 00:15:01 GMT) Full text and rfc822 format available.

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#611; Package x2goclient. (Wed, 05 Nov 2014 10:25:01 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Dmitry E. Mikhailov" <d.mikhailov@infocommunications.ru>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Wed, 05 Nov 2014 10:25:01 GMT) Full text and rfc822 format available.

Message #88 received at 611@bugs.x2go.org (full text, mbox):

From: "Dmitry E. Mikhailov" <d.mikhailov@infocommunications.ru>
To: 611@bugs.x2go.org
Subject: Fixed in preview/4.0.3.0-pre01 but still persists in release/4.0.3.0
Date: Wed, 05 Nov 2014 14:59:43 +0500
Hi everyone,

I'd like to notice that this bug is fixed in preview/4.0.3.0-pre01:
http://code.x2go.org/releases/binary-win32/x2goclient/previews/4.0.3.0/x2goclient-4.0.3.0-pre01-setup.exe 


but it still persists in release/4.0.3.0:
http://code.x2go.org/releases/binary-win32/x2goclient/releases/4.0.3.0-20141021/x2goclient-4.0.3.0-20141021-setup.exe


Please do apply the fix to the release version.

Best regards,
	Dmitry Mikhailov


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#611; Package x2goclient. (Wed, 05 Nov 2014 11:15:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Wed, 05 Nov 2014 11:15:02 GMT) Full text and rfc822 format available.

Message #93 received at 611@bugs.x2go.org (full text, mbox):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: "Dmitry E. Mikhailov" <d.mikhailov@infocommunications.ru>, 611@bugs.x2go.org
Subject: Re: [X2Go-Dev] Bug#611: Fixed in preview/4.0.3.0-pre01 but still persists in release/4.0.3.0
Date: Wed, 05 Nov 2014 11:13:09 +0000
[Message part 1 (text/plain, inline)]
Hi!

On  Mi 05 Nov 2014 10:59:43 CET, Dmitry E. Mikhailov wrote:

> Hi everyone,
>
> I'd like to notice that this bug is fixed in preview/4.0.3.0-pre01:
> http://code.x2go.org/releases/binary-win32/x2goclient/previews/4.0.3.0/x2goclient-4.0.3.0-pre01-setup.exe but it still persists in  
> release/4.0.3.0:
> http://code.x2go.org/releases/binary-win32/x2goclient/releases/4.0.3.0-20141021/x2goclient-4.0.3.0-20141021-setup.exe
>
>
> Please do apply the fix to the release version.
>
> Best regards,
> 	Dmitry Mikhailov

@Mike#2, George: can you confirm the above observation?

@Mike#2: can you close #611 then?

Thanks,
Mike#1

-- 

DAS-NETZWERKTEAM
mike gabriel, herweg 7, 24357 fleckeby
fon: +49 (1520) 1976 148

GnuPG Key ID 0x25771B31
mail: mike.gabriel@das-netzwerkteam.de, http://das-netzwerkteam.de

freeBusy:
https://mail.das-netzwerkteam.de/freebusy/m.gabriel%40das-netzwerkteam.de.xfb
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#611; Package x2goclient. (Thu, 06 Nov 2014 11:40:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to "George Trakatelis" <trakatelis@uom.edu.gr>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Thu, 06 Nov 2014 11:40:02 GMT) Full text and rfc822 format available.

Message #98 received at 611@bugs.x2go.org (full text, mbox):

From: "George Trakatelis" <trakatelis@uom.edu.gr>
To: <611@bugs.x2go.org>
Cc: <mike.gabriel@das-netzwerkteam.de>, <mikedep333@gmail.com>, <d.mikhailov@infocommunications.ru>
Subject: X2Go Client for Windows cannot create C:\Users\<username>\ssh\known_hosts file when the username has characters from languages other than the system locale
Date: Thu, 6 Nov 2014 13:37:41 +0200
Hi all, 

I remind you that bug #566 
'X2Go Client for Windows cannot create C:\Users\<username>\ssh\known_hosts
file when the username has non-English characters' 
was cloned to bug #611 
'X2Go Client for Windows cannot create C:\Users\<username>\ssh\known_hosts
file when the username has characters from languages other than the system
locale' 
in an effort to find a global solution utilizing UTF-8 encoding. 
Imho, bug #611 cannot be resolved in the near future.

I must ask Dmitry to re-state what his problem is. 
Is it an issue related to 

a. bug #566 as described above, 
b. bug #611 as described above, 
c. or something different? 

Please provide details. 

George



Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#611; Package x2goclient. (Thu, 06 Nov 2014 12:15:01 GMT) Full text and rfc822 format available.

Acknowledgement sent to cwe@osmigratie.nl:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Thu, 06 Nov 2014 12:15:01 GMT) Full text and rfc822 format available.

Message #103 received at 611@bugs.x2go.org (full text, mbox):

From: cwe <cwe@osmigratie.nl>
To: George Trakatelis <trakatelis@uom.edu.gr>, 611@bugs.x2go.org
Subject: Re: [X2Go-Dev] Bug#611: X2Go Client for Windows cannot create C:\Users\<username>\ssh\known_hosts file when the username has characters from languages other than the system locale
Date: Thu, 06 Nov 2014 15:04:56 +0100
[Message part 1 (text/plain, inline)]
 

Hi, 

Is it possible to "echo <username> | md5sum"? In this way all input will
be converted to UTF-8.
Finally the path will look something like
c:Usersffc01acb1953149574dd9f3a4f8a662sshknown_hosts. 

Or will this lead to inconsistency? 

Regards, 

Kees Epema 

On 2014-11-06 12:37, George Trakatelis wrote: 

> Hi all, 
> 
> I remind you that bug #566 
> 'X2Go Client for Windows cannot create C:Users<username>sshknown_hosts
> file when the username has non-English characters' 
> was cloned to bug #611 
> 'X2Go Client for Windows cannot create C:Users<username>sshknown_hosts
> file when the username has characters from languages other than the system
> locale' 
> in an effort to find a global solution utilizing UTF-8 encoding. 
> Imho, bug #611 cannot be resolved in the near future.
> 
> I must ask Dmitry to re-state what his problem is. 
> Is it an issue related to 
> 
> a. bug #566 as described above, 
> b. bug #611 as described above, 
> c. or something different? 
> 
> Please provide details. 
> 
> George
> _______________________________________________
> x2go-dev mailing list
> x2go-dev@lists.x2go.org
> http://lists.x2go.org/listinfo/x2go-dev [1]

-- 

OSmigratie: deel wat u weet, weet wat u deelt
osmigratie.nl
 

Links:
------
[1] http://lists.x2go.org/listinfo/x2go-dev
[Message part 2 (text/html, inline)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#611; Package x2goclient. (Thu, 06 Nov 2014 16:45:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to "George Trakatelis" <trakatelis@uom.edu.gr>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Thu, 06 Nov 2014 16:45:02 GMT) Full text and rfc822 format available.

Message #108 received at 611@bugs.x2go.org (full text, mbox):

From: "George Trakatelis" <trakatelis@uom.edu.gr>
To: <611@bugs.x2go.org>
Cc: "'Mike Gabriel'" <mike.gabriel@das-netzwerkteam.de>, "'Mike DePaulo'" <mikedep333@gmail.com>, "'Dmitry E. Mikhailov'" <d.mikhailov@infocommunications.ru>
Subject: RE: X2Go Client for Windows cannot create C:\Users\<username>\ssh\known_hosts file when the username has characters from languages other than the system locale
Date: Thu, 6 Nov 2014 18:43:51 +0200
I just noticed that Dmitry replied only to me, 
so I copy his reply below: 

==========================================================
It's the #566
No-go if OS locale is Russian & path to `known_hosts' contains
Russian/Cyrillic characters.
OK if if OS locale is Russian & path to `known_hosts' contains only English
characters.
Frankly, I don't know if generic English/Latin characters belong to
Russian/Cyrillic character set.
Best regards,
	Dmitry Mikhailov.
==========================================================

Afaik, the patch is applied to both the preview (pre01) 
and the current release (20141021) of X2Go Client for Windows 4.0.3.0, 
so it's rather unusual to observe different behavior from preview to
release. 
In my system (Greek Windows 8.1) with a user name in Cyrillic (фисвуа) 
(fyi, I pressed a-b-c-d-e-f to get it) and Greek locale 
both versions exhibited the same erroneous behavior 
(that's why Mike#2 introduced bug #611). 

I'll try to set Russian as the main language of my system to see what
happens 
(if I can find my way in Russian and succeed in getting back to Greek :)

George

> -----Original Message-----
> From: Dmitry E. Mikhailov [mailto:d.mikhailov@infocommunications.ru]
> Sent: Thursday, November 6, 2014 1:45 PM
> To: George Trakatelis
> Subject: Re: X2Go Client for Windows cannot create
> C:\Users\<username>\ssh\known_hosts file when the username has
> characters from languages other than the system locale
> 
> On 11/06/2014 04:37 PM, George Trakatelis wrote:
> > Hi all,
> >
> > I remind you that bug #566
> > 'X2Go Client for Windows cannot create
> > C:\Users\<username>\ssh\known_hosts
> > file when the username has non-English characters'
> > was cloned to bug #611
> > 'X2Go Client for Windows cannot create
> > C:\Users\<username>\ssh\known_hosts
> > file when the username has characters from languages other than the
> > system locale'
> > in an effort to find a global solution utilizing UTF-8 encoding.
> > Imho, bug #611 cannot be resolved in the near future.
> >
> > I must ask Dmitry to re-state what his problem is.
> > Is it an issue related to
> >
> > a. bug #566 as described above,
> It's the #566
> 
> No-go if OS locale is Russian & path to `known_hosts' contains
> Russian/Cyrillic characters.
> 
> OK if if OS locale is Russian & path to `known_hosts' contains only
> English characters.
> 
> Frankly, I don't know if generic English/Latin characters belong to
> Russian/Cyrillic character set.
> 
> Best regards,
> 	Dmitry Mikhailov.



Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#611; Package x2goclient. (Thu, 06 Nov 2014 18:20:01 GMT) Full text and rfc822 format available.

Acknowledgement sent to "George Trakatelis" <trakatelis@uom.edu.gr>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Thu, 06 Nov 2014 18:20:01 GMT) Full text and rfc822 format available.

Message #113 received at 611@bugs.x2go.org (full text, mbox):

From: "George Trakatelis" <trakatelis@uom.edu.gr>
To: <611@bugs.x2go.org>
Cc: "'Dmitry E. Mikhailov'" <d.mikhailov@infocommunications.ru>, "'Mike DePaulo'" <mikedep333@gmail.com>, "'Mike Gabriel'" <mike.gabriel@das-netzwerkteam.de>
Subject: RE: X2Go Client for Windows cannot create C:\Users\<username>\ssh\known_hosts file when the username has characters from languages other than the system locale
Date: Thu, 6 Nov 2014 20:16:40 +0200
Dear Dmitry,

Setting Russian as the default language for non-Unicode programs showed that

x2goclient-4.0.3.0-20141021-setup.exe behaves correctly with test user name
фисвуа. 

[To change system locale, I followed the instructions in 
http://windows.microsoft.com/en-us/windows/change-system-locale#1TC=windows-
7]

So please investigate for other causes for the misbehavior of x2goclient's
current release on your system.
One such a cause would be known_hosts being read-only. 

[@Mike#2: ssh_write_knownhost()'s return value should have been checked 
whether it's zero or SSH_ERROR and acted upon]

As there are portions of x2goclient that depend on code that ignores system
locale [such as getenv( "USERNAME" )], 
you'd be better off if you didn't use user names with non-Ascii characters
for the time being. 

George

> -----Original Message-----
> From: George Trakatelis [mailto:trakatelis@uom.edu.gr]
> Sent: Thursday, November 6, 2014 6:44 PM
> To: '611@bugs.x2go.org'
> Cc: 'Mike Gabriel'; 'Mike DePaulo'; 'Dmitry E. Mikhailov'
> Subject: RE: X2Go Client for Windows cannot create
> C:\Users\<username>\ssh\known_hosts file when the username has
> characters from languages other than the system locale
> 
> I just noticed that Dmitry replied only to me, so I copy his reply
> below:
> 
> ==========================================================
> It's the #566
> No-go if OS locale is Russian & path to `known_hosts' contains
> Russian/Cyrillic characters.
> OK if if OS locale is Russian & path to `known_hosts' contains only
> English characters.
> Frankly, I don't know if generic English/Latin characters belong to
> Russian/Cyrillic character set.
> Best regards,
> 	Dmitry Mikhailov.
> ==========================================================
> 
> Afaik, the patch is applied to both the preview (pre01) and the current
> release (20141021) of X2Go Client for Windows 4.0.3.0, so it's rather
> unusual to observe different behavior from preview to release.
> In my system (Greek Windows 8.1) with a user name in Cyrillic (фисвуа)
> (fyi, I pressed a-b-c-d-e-f to get it) and Greek locale both versions
> exhibited the same erroneous behavior (that's why Mike#2 introduced bug
> #611).
> 
> I'll try to set Russian as the main language of my system to see what
> happens (if I can find my way in Russian and succeed in getting back to
> Greek :)
> 
> George
> 
> > -----Original Message-----
> > From: Dmitry E. Mikhailov [mailto:d.mikhailov@infocommunications.ru]
> > Sent: Thursday, November 6, 2014 1:45 PM
> > To: George Trakatelis
> > Subject: Re: X2Go Client for Windows cannot create
> > C:\Users\<username>\ssh\known_hosts file when the username has
> > characters from languages other than the system locale
> >
> > On 11/06/2014 04:37 PM, George Trakatelis wrote:
> > > Hi all,
> > >
> > > I remind you that bug #566
> > > 'X2Go Client for Windows cannot create
> > > C:\Users\<username>\ssh\known_hosts
> > > file when the username has non-English characters'
> > > was cloned to bug #611
> > > 'X2Go Client for Windows cannot create
> > > C:\Users\<username>\ssh\known_hosts
> > > file when the username has characters from languages other than the
> > > system locale'
> > > in an effort to find a global solution utilizing UTF-8 encoding.
> > > Imho, bug #611 cannot be resolved in the near future.
> > >
> > > I must ask Dmitry to re-state what his problem is.
> > > Is it an issue related to
> > >
> > > a. bug #566 as described above,
> > It's the #566
> >
> > No-go if OS locale is Russian & path to `known_hosts' contains
> > Russian/Cyrillic characters.
> >
> > OK if if OS locale is Russian & path to `known_hosts' contains only
> > English characters.
> >
> > Frankly, I don't know if generic English/Latin characters belong to
> > Russian/Cyrillic character set.
> >
> > Best regards,
> > 	Dmitry Mikhailov.



Send a report that this bug log contains spam.


X2Go Developers <owner@bugs.x2go.org>. Last modified: Wed Dec 12 06:10:26 2018; Machine Name: ymir.das-netzwerkteam.de

X2Go Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.